Subject: bug#35771: [PATCH] Customization type of recentf-max-saved-items

From: Drew Adams <[email-masked]>
Date: Fri, 17 May 2019 06:36:30 -0700 (PDT)

> The customization type of recentf-max-saved-items is currently defined
> as integer, which does not include nil in its domain.  However, setting
> this variable to nil is supported in the code and also documented.
> 
> This patch changes the customization type to explicitly allow for the
> variable to be set to nil through the Customization interface and
> similar.  (Please note that I copied the type from save-place-limit in
> order to be consistent.)

(I'm looking at Emacs 26.2, so apologies if the Emacs 27
code has already fixed this.)

The code should also be changed to do one of the following:

1. Use `abs' when the variable value is used.

2. Use `restricted-sexp' in the defcustom :type, to require
   the value to be a non-negative (or possibly a positive?)
   integer (or nil).

I'm guessing there are additional places in Emacs code
where :type 'integer is used but a non-negative integer is
really needed/appropriate.  It would be good to improve
those :type specs as well.

(We might also want to consider adding `natnum' or
`nonnegative-integer', `positive-integer' and
`negative-integer' as possible :type values.)

But it is simple to use `restricted-sexp' to control such
things.  And not only would that improve the behavior for
users; it would also, by way of model, encourage users to
use `restricted-sexp' in their own code.

Emacs-Lisp code delivered with Emacs is not a great model
in this respect.  It rarely uses `restricted-sexp' - at
least it uses it much less than it could/should (IMHO).

More generally, the distributed Emacs code is pretty
"lazy" when it comes to providing defcustom definitions -
few :tag descriptions, overly general :type specs, etc.

E.g.,

(defcustom recentf-max-saved-items 20
  "Maximum number of recently used file names to save.
`nil' means save the whole list.
See command `recentf-save-list'."
  :group 'recentf
  :type '(choice 
          (restricted-sexp
           :tag "Save no more than this many file names"
           :match-alternatives
           ((lambda (x) (and (natnump x) (not (zerop x)))))
           :value ignore)
          (const :tag "Save all file names" nil)))